<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.23">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../favicon.png">
  <title>Global definitions | Chi documentation</title>
  <link rel="stylesheet" href="../assets/asciidoctor-escet-chi.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../assets/styles/asciidoctor-highlightjs-escet.min.css"> <!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="../assets/asciidoctor-escet-chi.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="..">Chi website</a></p>
    <div id="toctitle">
     Chi documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../documentation.html">Home</a></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/index.html">Chi Tutorial</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/introduction.html">Introduction</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/introduction.html#chi-in-a-nutshell">Chi in a nutshell</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/introduction.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/datatypes.html">Data types</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/datatypes.html#elementary-types">Elementary types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#booleans">Booleans</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#enumerations">Enumerations</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#numbers">Numbers</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#strings">Strings</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/datatypes.html#tuple-types">Tuple types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#notation">Notation</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#operator">Operator</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/datatypes.html#container-types">Container types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#lists">Lists</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#initialization">Initialization</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#sets">Sets</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#dictionaries">Dictionaries</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#custom-types">Custom types</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/statements.html">Statements</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#the-assignment-statement">The assignment statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#the-if-statement">The <code>if</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#the-while-statement">The <code>while</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#the-for-statement">The <code>for</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#notes">Notes</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/functions.html">Functions</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/functions.html#sorted-lists">Sorted lists</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/functions.html#sort">Sort</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/functions.html#insert">Insert</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/input-output.html">Input and output</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#the-read-function">The <code>read</code> function</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#reading-from-a-file">Reading from a file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#advanced-reading-from-a-file">Advanced reading from a file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#the-write-statement">The <code>write</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#writing-to-a-file">Writing to a file</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/stochastic-behavior.html">Modeling stochastic behavior</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/stochastic-behavior.html#distributions">Distributions</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#constant-distributions">Constant distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#discrete-distributions">Discrete distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#continuous-distributions">Continuous distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#references">References</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#simulating-stochastic-behavior">Simulating stochastic behavior</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/processes.html">Processes</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/processes.html#a-single-process">A single process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/processes.html#a-process-in-a-process">A process in a process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/processes.html#many-processes">Many processes</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/channels.html">Channels</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#a-channel">A channel</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#synchronization-channels">Synchronization channels</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#two-channels">Two channels</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#more-senders-or-receivers">More senders or receivers</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#notes">Notes</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/buffers.html">Buffers</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#a-one-place-buffer">A one-place buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#a-single-process-buffer">A single process buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#an-infinite-buffer">An infinite buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#a-token-buffer">A token buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#a-priority-buffer">A priority buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/servers.html">Servers with time</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/servers.html#the-clock">The clock</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/servers.html#adding-time">Adding time</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/servers.html#a-deterministic-system">A deterministic system</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/servers.html#a-stochastic-system">A stochastic system</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/servers.html#two-servers">Two servers</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/servers.html#serial-system">Serial system</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/servers.html#parallel-systems">Parallel systems</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/servers.html#assembly">Assembly</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/servers.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/conveyors.html">Conveyors</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/conveyors.html#timers">Timers</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/conveyors.html#a-conveyor">A conveyor</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/conveyors.html#a-priority-conveyor">A priority conveyor</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/conveyors.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/experiments.html">Simulations and experiments</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/experiments.html#simulating-finite-systems">Simulating finite systems</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/experiments.html#simulating-infinite-systems">Simulating infinite systems</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/experiments.html#simulating-several-scenarios">Simulating several scenarios</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/svg-visualization.html">SVG visualization</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-visualization.html#the-svg-file-format">The SVG file format</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-visualization.html#visualization">Visualization</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/svg-example.html">SVG visualization example</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#buffer-visualization">Buffer visualization</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#vertical-coordinates-trickery">Vertical coordinates trickery</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#server-process">Server process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#visualizing-the-server">Visualizing the server</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#copying-svg-elements">Copying SVG elements</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#moving-svg-elements">Moving SVG elements</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="index.html">Chi Reference Manual</a>
      <ul class="sectlevel2">
       <li class="toc-cur-page toc-item toc-item-parent expanded">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">Global definitions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#enumeration-definitions">Enumeration definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#type-definitions">Type definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#constant-definitions">Constant definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#process-definitions">Process definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#model-definitions">Model definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#function-definitions">Function definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#experiment-definitions">Experiment definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#formal-parameters">Formal parameters</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html">Statements</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#local-variables">Local variables</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#assignment-statement">Assignment statement</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html#iterative-statements">Iterative statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#while-loop-statement">While loop statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#for-loop-statement">For loop statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#break-statement">Break statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#continue-statement">Continue statement</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#choice-statement">Choice statement</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html#sub-process-statements">Sub-process statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#run-and-start-statements">Run and start statements</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#finish-statement">Finish statement</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html#communication-statements">Communication statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#send-statement">Send statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#receive-statement">Receive statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#select-statement">Select statement</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html#other-statements">Other statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#delay-statement">Delay statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#write-statement">Write statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#close-statement">Close statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#return-statement">Return statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#exit-statement">Exit statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#pass-statement">Pass statement</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="expressions.html">Expressions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#typed-expressions">Typed expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#enumeration-value">Enumeration value</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#boolean-expressions">Boolean expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#integer-expressions">Integer expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#real-number-expressions">Real number expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#string-expressions">String expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#list-expressions">List expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#set-expressions">Set expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#dictionary-expressions">Dictionary expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#tuple-expression">Tuple expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#file-handle-expressions">File handle expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#read-expression">Read expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#timer-expressions">Timer expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#channel-expressions">Channel expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#distribution-expressions">Distribution expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#process-expressions">Process expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#instance-expressions">Instance expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#matrix-expression">Matrix expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#cast-expressions">Cast expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#function-call-expressions">Function call expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#operator-priorities">Operator priorities</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="stdlib.html">Standard library functions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#integer-functions">Integer functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#real-number-functions">Real number functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#string-functions">String functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#list-functions">List functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#set-functions">Set functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#dictionary-functions">Dictionary functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#timer-functions">Timer functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#file-functions">File functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#process-instance-functions">Process instance functions</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="distributions.html">Distributions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="distributions.html#constant-distributions">Constant distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="distributions.html#discrete-distributions">Discrete distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="distributions.html#continuous-distributions">Continuous distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="distributions.html#references">References</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="types.html">Types</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="types.html#elementary-types">Elementary types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#boolean-type">Boolean type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#integer-type">Integer type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#real-type">Real type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#string-type">String type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#file-type">File type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#instance-type">Instance type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#timer-type">Timer type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#matrix-type">Matrix type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#void-type">Void type</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="types.html#container-types">Container types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#list-type">List type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#set-type">Set type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#dictionary-type">Dictionary type</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#tuple-type">Tuple type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#channel-type">Channel type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#distribution-type">Distribution type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#function-type">Function type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#process-type">Process type</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="lexicals.html">Lexical syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="lexicals.html#whitespace">Whitespace</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="lexicals.html#comment">Comment</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="lexicals.html#names">Names</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="migration.html">Model migration</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="svg-visualization.html">SVG visualization</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-visualization.html#svg-interface">SVG interface</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-visualization.html#visualization-modification-commands">Visualization modification commands</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/index.html">Chi Tool Manual</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/operation.html">Software operation</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/operation.html#compile-and-simulate">Compile and simulate</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#quick-simulate">Quick simulate</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#compile-only">Compile only</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#simulate-a-compiled-model">Simulate a compiled model</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#terminating-a-simulation">Terminating a simulation</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/command-line.html">Command line options</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#simulator-options">Simulator options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#general-application-options">General application options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#compiler-options">Compiler options</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../release-notes.html">Chi release notes</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-5-0-2024-10-03">Version 5.0 (2024-10-03)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-4-0-2024-06-30">Version 4.0 (2024-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-3-0-2024-03-31">Version 3.0 (2024-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-2-0-2023-12-22">Version 2.0 (2023-12-22)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-1-0-2023-09-30">Version 1.0 (2023-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-10-2023-06-30">Version 0.10 (2023-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-9-2023-03-31">Version 0.9 (2023-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-8-2022-12-21">Version 0.8 (2022-12-21)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-7-2022-09-30">Version 0.7 (2022-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-6-2022-07-07">Version 0.6 (2022-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-5-2022-03-29">Version 0.5 (2022-03-29)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-4-2021-12-17">Version 0.4 (2021-12-17)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-3-2021-10-01">Version 0.3 (2021-10-01)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-2-2021-07-07">Version 0.2 (2021-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-1-2021-04-02">Version 0.1 (2021-04-02)</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../documentation-legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../documentation.html">Chi documentation</a> &gt; <a class="breadcrumb" href="index.html">Chi Reference Manual</a> &gt; <span class="breadcrumb">Global definitions</span>
   </div>
   <h2 id="global-definitions"><a class="anchor" href="#"></a>Global definitions</h2>
   <div class="paragraph">
    <p>At global level, a Chi program is a sequence of definitions, as shown in the following diagram.</p>
   </div>
   <div class="imageblock">
    <div class="content"><img src="rail_diagrams/program.rr.png" alt="program.rr">
    </div>
   </div>
   <div class="paragraph">
    <p>Each of the definitions is explained below. The syntax diagram suggests that a <code>;</code> separator is obligatory between definitions. The implementation is more liberal, you may omit the separator when a definition ends with the <code>end</code> keyword. Also, it is allowed to use a separator after the last definition.</p>
   </div>
   <div class="paragraph">
    <p>The name of each global definition has to be unique.</p>
   </div>
   <div class="sect3">
    <h3 id="enumeration-definitions"><a class="anchor" href="#enumeration-definitions"></a>Enumeration definitions</h3>
    <div class="paragraph">
     <p>With enumerations, you create a new enumeration type containing a number of names (called enumeration values). The syntax is given below.</p>
    </div>
    <div class="imageblock">
     <div class="content"><img src="rail_diagrams/enumdef.rr.png" alt="enumdef.rr">
     </div>
    </div>
    <div class="paragraph">
     <p>The enumeration definitions start with the keyword <code>enum</code>, followed by a sequence of definitions separated with a <code>,</code>. Each definition associates an enumeration type name with a set of enumeration value names. For example:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">enum FlagColours  = {red, white, blue},
     MachineState = {idle, heating, processing};</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>The enumeration type names act as normal types, and the enumeration values are its values. The values have to be unique words.</p>
    </div>
    <div class="paragraph">
     <p>For example, you can create a variable, and compare values like:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">MachineState state = idle;
...
while state != processing:
    ...
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Note that enumeration values have no order, you cannot increment or decrement variables with an enumeration type, and you can only compare values with equality and inequality.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="type-definitions"><a class="anchor" href="#type-definitions"></a>Type definitions</h3>
    <div class="paragraph">
     <p>Type definitions allow you to assign a name to a type. By using a name instead of the type itself, readability of the program increases.</p>
    </div>
    <div class="imageblock">
     <div class="content"><img src="rail_diagrams/typedef.rr.png" alt="typedef.rr">
     </div>
    </div>
    <div class="paragraph">
     <p>A type definition starts with the keyword <code>type</code>, followed by a number of 'assignments' that associate a type name with a type, separated with a <code>,</code>. For further details about type names and types, see <a href="types.html">Types</a>.</p>
    </div>
    <div class="paragraph">
     <p>An example:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">type lot   = real,
     batch = list lot;</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Here a <code>lot</code> type name is introduced that is implemented with a real number, and a <code>batch</code> type name is created, which is a list of <code>lot</code>.</p>
    </div>
    <div class="paragraph">
     <p>These type names can be used at every place where you can use a type, for example in variable declarations:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">batch xs;
lot x;</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Note that you cannot define use a type name in its own definition.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="constant-definitions"><a class="anchor" href="#constant-definitions"></a>Constant definitions</h3>
    <div class="paragraph">
     <p>Constant definitions allow you to give a name to a fixed value to enhance readability. It also makes it easier to change a value between different experiments. For example, if you have a constant named <code>speed</code>, and you want to investigate how its value affects performance, you only have to change value in the constant definition, instead of finding and changing numbers in the entire program.</p>
    </div>
    <div class="paragraph">
     <p>The syntax of constant definitions is as follows.</p>
    </div>
    <div class="imageblock">
     <div class="content"><img src="rail_diagrams/constantdef.rr.png" alt="constantdef.rr">
     </div>
    </div>
    <div class="paragraph">
     <p>An example:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">const real speed = 4.8,
      dict(string : list int) recipes = { "short" : [1,4,8],
                                          "long"  : [1,1,2,3,4,5] };</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Here, a <code>speed</code> real value is defined, and <code>recipes</code> value, a dictionary of string to numbers. The constant names can be used at every point where you can use an expression. See the <a href="expressions.html">Expressions</a> section for details about expressions.</p>
    </div>
    <div class="paragraph">
     <p>Note that you cannot use a constant name in its own definition.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="process-definitions"><a class="anchor" href="#process-definitions"></a>Process definitions</h3>
    <div class="paragraph">
     <p>A process is an entity that shows behavior over time. A process definition is a template for such a process. It is defined as follows.</p>
    </div>
    <div class="imageblock">
     <div class="content"><img src="rail_diagrams/procdef.rr.png" alt="procdef.rr">
     </div>
    </div>
    <div class="paragraph">
     <p>The definition starts with the keyword <code>proc</code> optionally followed by an exit type. The name of the process definition, and its formal parameters concludes the header. In the body, the behavior is described using statements.</p>
    </div>
    <div class="paragraph">
     <p>Formal parameters are further explained in <a href="#formal-parameters">Formal parameters</a>, statements are explained in the <a href="statements.html">Statements</a> section.</p>
    </div>
    <div class="paragraph">
     <p>For example:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">proc P():
  writeln("Hello");
  delay 15;
  writeln("Finished")
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>In the example, a process definition with the name <code>P</code> is defined, without parameters, that outputs a line of text when starting, and another line of text 15 time units later (and then finishes execution).</p>
    </div>
    <div class="paragraph">
     <p>Creating and running a process is done with <a href="statements.html#sub-process-statements">Sub-process statements</a> (<code>start</code> or <code>run</code>) from another process or from a model.</p>
    </div>
    <div class="paragraph">
     <p>If a process definition has no exit type specified, it may not use the <code>exit</code> statement, nor may it start other processes that have an exit type (see also <a href="statements.html#sub-process-statements">Sub-process statements</a>). Process definitions that have an exit type may use the <code>exit</code> statement directly (see <a href="statements.html#exit-statement">Exit statement</a> for details on the statement), and it may start other processes without exit type, or with the same exit type.</p>
    </div>
    <div class="paragraph">
     <p>Since values returned by the <code>exit</code> statement may get printed onto the output, you may only use exit types that are printable. These are all the 'normal' data values, from simple booleans to lists, sets, and dictionaries of data values, but not channels, files, etc.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="model-definitions"><a class="anchor" href="#model-definitions"></a>Model definitions</h3>
    <div class="paragraph">
     <p>A model behaves like a process, the only difference is that a model is run as first process. It is the 'starting point' of a simulation. As such, a model can only take data values which you can write down as literal value. For example, giving it a channel or a process instance is not allowed.</p>
    </div>
    <div class="paragraph">
     <p>Like the process, a model also has a definition. It is defined below.</p>
    </div>
    <div class="imageblock">
     <div class="content"><img src="rail_diagrams/modeldef.rr.png" alt="modeldef.rr">
     </div>
    </div>
    <div class="paragraph">
     <p>The syntax is exactly the same as process definitions explained in <a href="#process-definitions">Process definitions</a>, except it starts with a <code>model</code> keyword instead. A model can be started directly in the simulator (see <a href="../tool-manual/operation.html">Software operation</a>), or as part of an experiment, explained in <a href="../tutorial/experiments.html#simulating-several-scenarios">Simulating several scenarios</a>, and <a href="#experiment-definitions">Experiment definitions</a>. If the model definition has no exit type, it may not use the <code>exit</code> statement directly, nor may it start other processes that have an exit type. If an exit type is specified, the model may use the <code>exit</code> statement to end the model simulation (see <a href="statements.html#sub-process-statements">Sub-process statements</a> for details), and it may start other processes, either without exit type, or with a matching exit type.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="function-definitions"><a class="anchor" href="#function-definitions"></a>Function definitions</h3>
    <div class="paragraph">
     <p>In programs, computations are executed to make decisions. These computations can be long and complex. A function definition attaches a name to a computation, so it can be moved to a separate place in the file.</p>
    </div>
    <div class="paragraph">
     <p>Another common pattern is that the same computation is needed at several places in the program. Rather than duplicating it (which creates consistency problems when updating the computation), write it in a function definition, and call it by name when needed.</p>
    </div>
    <div class="paragraph">
     <p>The syntax of a function definition is as follows.</p>
    </div>
    <div class="imageblock">
     <div class="content"><img src="rail_diagrams/funcdef.rr.png" alt="funcdef.rr">
     </div>
    </div>
    <div class="paragraph">
     <p>In the syntax, the only thing that changes compared with the syntax in <a href="#process-definitions">Process definitions</a> or <a href="#model-definitions">Model definitions</a> is the additional <code>Type</code> node that defines the type resulting from the computation.</p>
    </div>
    <div class="paragraph">
     <p>However, since a function represents a computation (that is, calculation of an output value from input values) rather than having behavior over time, the <code>Body</code> part has additional restrictions.</p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>A computation is performed instantly, no time passes. This means that you cannot delay or wait in a function.</p></li>
      <li><p>A computation outputs a result. You cannot have a function that has no result.</p></li>
      <li><p>A computation is repeatable. That means if you run the same computation again with the same input values, you get the same result <em>every time</em>. Also in the environment of the function, there should be no changes. This idea is known as <em>mathematical functions</em>.</p>
       <div class="paragraph">
        <p>A consequence of having mathematical functions is that you cannot interact with 'outside'. No querying of the current time, no communication, no select statement, and no use of distributions.</p>
       </div>
       <div class="paragraph">
        <p>Technically, this would also imply no input/output, but for practical reasons this restriction has been lifted. However, as a general rule, avoid using it.</p>
       </div></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="experiment-definitions"><a class="anchor" href="#experiment-definitions"></a>Experiment definitions</h3>
    <div class="paragraph">
     <p>An experiment can execute one or more model simulations, collect their exit values, and combine them into a experiment result. Its syntax is shown below.</p>
    </div>
    <div class="imageblock">
     <div class="content"><img src="rail_diagrams/xperdef.rr.png" alt="xperdef.rr">
     </div>
    </div>
    <div class="paragraph">
     <p>An experiment definition has some function-like restrictions, like not being able to use sub-process statements, no communication, and no use of time. On the other hand, it does not return a value, and it can start model simulations that have a non-void exit type (<a href="types.html#void-type">Void type</a> discusses the void type).</p>
    </div>
    <div class="paragraph">
     <p>The definition is very similar to other definitions. It starts with an <code>xper</code> keyword, followed by the name of the definition. The name can be used to start an experiment with the simulator (see <a href="../tool-manual/operation.html">Software operation</a> for details on starting the simulator). If formal parameters are specified with the experiment definition (see <a href="#formal-parameters">Formal parameters</a> below), the experiment can be parameterized with values. Like models, an experiment can only take data values which you can write down as literal value. For example, giving it a channel or a process instance is not allowed.</p>
    </div>
    <div class="paragraph">
     <p>The body of an experiment is just like the body of a <a href="#function-definitions">Function definitions</a> (no interaction with processes or time). Unlike a function, an experiment never returns a value with the <a href="statements.html#return-statement">Return statement</a>.</p>
    </div>
    <div class="paragraph">
     <p>The primary goal of an <code>xper</code> is to allow you to run one or more model simulations that give an exit value. For this purpose, you can 'call' a model like a function, for example:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">xper X():
    real total;
    int n;

    while n &lt; 10:
        total = total + M();
        n = n + 1
    end

    writeln("Average is %.2f", total / 10);
end

model real M():
    dist real d = exponential(7.5);
    exit sample d;
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>The model above is very short to keep the example compact. In practice it will be larger, start several concurrent processes, and do a lengthy simulation before it decides what the answer should be. The experiment <code>X</code> makes ten calls to the model. Each call causes the model to be run, until the model or one of its processes executes the <code>exit</code> statement. At that point, the model and all its processes are killed, and the value supplied with the exit statement becomes the return value of the model call, adding it to <code>total</code>. After the ten model simulations, the experiment outputs the average value of all model simulations.</p>
    </div>
    <div class="paragraph">
     <p>Note that the called model (or one of its started processes) <strong>must</strong> end with the <code>exit</code> statement, it is an error when the model ends by finishing its last model statement.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="formal-parameters"><a class="anchor" href="#formal-parameters"></a>Formal parameters</h3>
    <div class="paragraph">
     <p>Definitions above often take values as parameter to allow customizing their behavior during execution. The definition of those parameters are called <em>formal parameters</em>. The syntax of formal parameters is shown below.</p>
    </div>
    <div class="imageblock">
     <div class="content"><img src="rail_diagrams/formalparms.rr.png" alt="formalparms.rr">
     </div>
    </div>
    <div class="paragraph">
     <p>As you can see, they are just variable declarations (explained in the <a href="statements.html#local-variables">Local variables</a> section), except you may not add an initial value, since their values are obtained during use of the definition.</p>
    </div>
    <div class="paragraph">
     <p>To a definition, the formal parameters act like variables. You may use them just like other variables.</p>
    </div>
    <div class="paragraph">
     <p>An example, where <code>int x, y; string rel</code> are the formal parameters of process definition <code>P</code>:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">proc P(int x, y; string rel):
    writeln("%d %s %d", x, rel, x-y)
end

...

run P(2, -1, "is less than");</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>The formal parameters introduce additional variables in the process, that can be just like any other variable. Here, they are just printed to the screen. Elsewhere in the program, the definition gets used (instantiated), and a value is supplied for the additional variables. Such values are called <em>actual parameters</em>.</p>
    </div>
   </div>
  </div>
  <script src="../assets/highlight.min.js"></script>
  <script src="../assets/languages/asciidoc.min.js"></script>
  <script src="../assets/languages/bash.min.js"></script>
  <script src="../assets/languages/bnf.min.js"></script>
  <script src="../assets/languages/c.min.js"></script>
  <script src="../assets/languages/chi.min.js"></script>
  <script src="../assets/languages/cif.min.js"></script>
  <script src="../assets/languages/console.min.js"></script>
  <script src="../assets/languages/css.min.js"></script>
  <script src="../assets/languages/dsm.min.js"></script>
  <script src="../assets/languages/java.min.js"></script>
  <script src="../assets/languages/javascript.min.js"></script>
  <script src="../assets/languages/markdown.min.js"></script>
  <script src="../assets/languages/mcrl2.min.js"></script>
  <script src="../assets/languages/none.min.js"></script>
  <script src="../assets/languages/plcst.min.js"></script>
  <script src="../assets/languages/properties.min.js"></script>
  <script src="../assets/languages/raildiagram.min.js"></script>
  <script src="../assets/languages/setext.min.js"></script>
  <script src="../assets/languages/shell.min.js"></script>
  <script src="../assets/languages/tooldef.min.js"></script>
  <script src="../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code[data-lang]')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script> <!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>Chi documentation</span> | <span>Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span> | <span>version v5.0</span><br> <a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>